#include <lv2plugin.hpp>


using namespace LV2;


class DFlipFlop : public Plugin<DFlipFlop> {
public:

  DFlipFlop(double rate)
    : Plugin<DFlipFlop>(5) {
	  m_lastclock = 0;
  }

  void run(uint32_t nframes) {
    if (*p(3) > 0 && *p(0) <= 0 && *p(2) > 0 && m_lastclock <= 0 && *p(1) != 0){
    	*p(1) = 0;
    	*p(4) = 1;
    }
    if (*p(3) > 0 && *p(0) > 0 && *p(2) > 0 && m_lastclock <= 0 && *p(1) != 1){
    	*p(1) = 1;
    	*p(4) = 0;
    }
    m_lastclock = *p(2);
  }

protected:
	float m_lastclock;
};


static int _ = DFlipFlop::register_class("http://uli-plugins.sourceforge.net/lv2/dflipflop");
