#include <lv2plugin.hpp>


using namespace LV2;


class Xnor2I : public Plugin<Xnor2I> {
public:

  Xnor2I(double rate)
    : Plugin<Xnor2I>(3) {

  }

  void run(uint32_t nframes) {
    if ((*p(0) > 0 && *p(1) <= 0) || (*p(0) <= 0 && *p(1) > 0))
    	*p(2) = 0;
    else
    	*p(2) = 1;
  }

};


static int _ = Xnor2I::register_class("http://uli-plugins.sourceforge.net/lv2/xnor2i");
